TACHYON
{

		UPDATED 20121123.1330 - BBR added LCD display
		UPDATED 20121123.1000 - BBR incorportaed PJ's suggestions
		CREATED 20121122.1800 - BB Riley, Underhill Center, VT  
		                        brianbr@wulfden.org
		BASEDON	code by Savage Circuits (spin) and Parallax (bs2)

		TESTED  Tachyon Forth V21 121114.1330 Extend 121113.1200
		
		Grayhill Incremental Rotary Encoder - Parallax p/n: 27805
		
		http://www.parallax.com/Portals/0/Downloads/docs/prod/acc/Series25LEncoder.pdf
}		
		
: QuadDecoder.fth	." Quadrature decoder driver"  ;

#P23	CONSTANT	L0			\ LCD port
#P26	CONSTANT	A0			\  A output from encoder
#P27	CONSTANT	B0			\  B output from encoder

LONG	oldBits,newBits,counter

: .STRING	( string -- )
	BEGIN C@++ ?DUP WHILE EMIT REPEAT DROP \ send string
	;
: QE@	( -- ) IN@	A0 SHR 3 AND ;	\ get current state	

: QDEC@	( -- )					\ QuadratureDecoder
	A0 PININP	B0 PININP		\  Set encoder pins to inputs
	QE@  oldBits !			\  Pre-initialize oldBits (prevents 
								\       non-zero starting count)
	BEGIN
    	QE@	DUP newBits !		\  read encoder
		oldBits @
		<> IF					\  compare oldBits to newBits. Has it changed?  
			newBits @ 1 AND		\  determine direction and add or subtract from counter
			oldBits @ 2/
			XOR 2* 1-
			counter +!
			newBits @ oldBits !  \ Update oldBits

			." ?x11?y0" counter @ $840A .NUM CR
		THEN

	KEY? AND UNTIL				  \  this could be replaced by a pushbutton and reading
								  \   a pin
	;
	
: LCDEMIT	L0 SEROUT ;
' LCDEMIT CONSTANT ULCD
: LCD		ULCD uemit W! ;

: QEDEMO1	( -- )
	#19200 SERBAUD
	$10		counter !			\  initialize counter
	LCD							\   redirect console
	." ?f counter = " counter @ $840A .NUM CR
	QDEC@
	CON							\  return mmconsole
	;
	

END

